; ===========================================================================
; User-programming macros
; ===========================================================================

; Macro to output the text
out	macro
	move.w	sr,(SysInputBuff+$34).w	; save sr
	movem.l	d0-a6,(SysRegBuff).w	; save registers
	lea	*+8,a0		; load text block
	bra.s	IOs\@		; skip text block
	dc.b	\1,0
	even
IOs\@	bsr.w	Console_OutText
	movem.l	(SysRegBuff).w,d0-a6	; restore registers
	move.w	(SysInputBuff+$34).w,sr	; restore sr
	endm
	

; Macro to output word integer
outb	macro
	move.w	sr,(SysInputBuff+$34).w	; save sr
	move.l	#0,(SysInputBuff).w	; clear input buffer
	move.b	\1,(SysInputBuff+3).w
	movem.l	d0-a6,(SysRegBuff).w	; save registers
	if (narg=2)
		move.b	#\2,d6	; set output type
	else
		moveq	#0,d6
	endc
	moveq	#0,d5	; set output mode to byte
	bsr.w	Console_OutNumber
	movem.l	(SysRegBuff).w,d0-a6	; restore registers
	move.w	(SysInputBuff+$34).w,sr	; restore sr
	endm


; Macro to output word integer
outw	macro                                                
	move.w	sr,(SysInputBuff+$34).w	; save sr
	move.l	#0,(SysInputBuff).w	; clear input buffer
	move.w	\1,(SysInputBuff+2).w             
	movem.l	d0-a6,(SysRegBuff).w	; save registers
	;todoh: save reg faka her!
	if (narg=2)
		move.b	#\2,d6	; set output type
	else
		moveq	#0,d6
	endc
	moveq	#8,d5	; set output mode to word
	bsr.w	Console_OutNumber
	movem.l	(SysRegBuff).w,d0-a6	; restore registers
	move.w	(SysInputBuff+$34).w,sr	; restore sr
	endm

; Macro to output long integer
outl	macro
	move.w	sr,(SysInputBuff+$34).w	; save sr
	move.l	\1,(SysInputBuff).w        
	movem.l	d0-a6,(SysRegBuff).w	; save registers
	if (narg=2)
		move.b	#\2,d6	; set output type
	else
		moveq	#0,d6
	endc
	moveq	#24,d5	; set output mode to word
	bsr.w	Console_OutNumber
	movem.l	(SysRegBuff).w,d0-a6	; restore registers
	move.w	(SysInputBuff+$34).w,sr	; restore sr
	endm

; Macro to break console
break	macro                                                 
	move.w	sr,(SysInputBuff+$34).w	; save sr
	movem.l	d0-a6,(SysRegBuff).w	; save registers    
	bsr.w	Console_Break
	movem.l	(SysRegBuff).w,d0-a6	; restore registers
	move.w	(SysInputBuff+$34).w,sr	; restore sr
	endm

; Macro to pause the program
pause	macro
	move.w	sr,(SysInputBuff+$34).w	; save sr
	movem.l	d0-a6,(SysRegBuff).w	; save registers
	move.l	#*+16,(SysPragmaPC).w
	move.b	#2,(SysModeId).w
	rts
	endm
	
; Macro to delay a program
delay	macro
	move.w	sr,(SysInputBuff+$34).w	; save sr
	movem.l	d0-a6,(SysRegBuff).w	; save registers
	move.b	#\1,(SysDelayCounter).w
	move.l	#*+16,(SysPragmaPC).w
	move.b	#4,(SysModeId).w
	rts
	endm
	
; Macro to clear console
cls	macro
	move.w	sr,(SysInputBuff+$34).w	; save sr
	movem.l	d0-a6,(SysRegBuff).w	; save registers
	bsr.w	Console_Init
	movem.l	(SysRegBuff).w,d0-a6	; restore registers
	move.w	(SysInputBuff+$34).w,sr	; restore sr
	endm