; Standart align macro
align	macro
	if (narg=1)
	dcb.b \1-(*%\1),0
	else
	dcb.b \1-(*%\1),\2
	endc
	endm

; Macro to set VDP VRAM write
vram	macro
	if (narg=1)
		move.l	#($40000000+((\1&$3FFF)<<16)+((\1&$C000)>>14)),($C00004).l
	else
		move.l	#($40000000+((\1&$3FFF)<<16)+((\1&$C000)>>14)),\2
	endc
	endm

; Macro to set VDP CRAM write
cram	macro
	if (narg=1)
		move.l	#($C0000000+(\1<<16)),($C00004).l
	else
		move.l	#($C0000000+(\1<<16)),\2
	endc
	endm

; Macro to raise error
raise	macro
	move.l	2(sp),d7 ;##################################################
	move.b	#\1,(SysErrorId).w
	bra.w	ShowError
	endm
	
; Macro to chk button press
tpress	macro
	if (narg=1)
		btst	#\1,(SysJoypadPress).w
	else
		move.b	(SysJoypadPress).w,d0
		andi.b	#(1<<\1)|(1<<\2),d0
	endc
	endm

; Macro to chk button held
theld	macro
	if (narg=1)
		btst	#\1,(SysJoypadHeld).w
	else
		move.b	(SysJoypadHeld).w,d0
		andi.b	#(1<<\1)|(1<<\2),d0
	endc
	endm