
; This is the code from Sonic 1 (Hivebrain's Disasm):

;#Sonic_Display:			; XREF: loc_12C7E
;#		move.w	$30(a0),d0	; move remaining invulnerability time to d0
;#		beq.s	Obj01_Display	; if it's zero, branch
;#		subq.w	#1,$30(a0)
;#		lsr.w	#3,d0
;#		bcc.s	Obj01_ChkInvin	; skip sprite displaying
;#
;#Obj01_Display:
;#		jsr	DisplaySprite

; The code seems to be clear and simple, but you can't get what do these lines do:

;#		subq.w	#1,$30(a0)
;#		lsr.w	#3,d0
;#		bcc.s	Obj01_ChkInvin	; skip sprite displaying

; Let's figure this out!
; Due to we don't have $30(a0), lets use $FF0000 instead!

		move.w	#120,($FF0000).l ; let's set invulnerability counter to 120
		
; The code from Sonic 1 was run every frame, let's emulate it...

FrameLoop:
		move.w	($FF0000).l,d0	; move remaining invulnerability time to d0
		beq.w	QuitLoop	; if it's zero, branch to quit (we'll have nothing to do then)
		
		subq.w	#1,($FF0000).l	; sub 1 from the counter (this is clear)
		
	; now we are going to look, what in the d0, since LSR is a bit operation, 
	; let's see it as binary number!
		outw	d0,bin		; let's output d0 before LSR operation
		break
		lsr.w	#3,d0		; shift 3 bits right
		outw	d0,bin		; look, what we've got after LSR
		
		bcc.s	SkipDisplay	; skip displaying, but when does BCC works?

Display:	out	'... Sonic!'	; sprite is displayed!

SkipDisplay:
		break
		pause		; delay for 2 frames
		bra.w   FrameLoop

QuitLoop:	rts

; Having run the program, but still can't get, how the code works?
; Here is some hints for you:
; 1) BCC = Branch When Carry is Clear
; 2) LSR sets Carry bit according to the last bit shifted

; Look at bit #2 in d0 before LSR (third, when counting from 1). It's the last bit shifted, yay!
; So, you see, that when it's cleared BCC works, and Sonic spite isn't displayed.
; Sonic's displaying/hidding lasts 2 ^ 2 = 4 frames.

; Summary: Yuji Naka is awesome. ^_^
