; ===========================================================================
; M68K Sandbox v.1.0
; (C) 2010, Vladikcomper
; ---------------------------------------------------------------------------
; Global variables definations
; ===========================================================================

; -------------------------------------------------------------------------------------------
; Joypad button state to make life easier
Start		equ 	7
A		equ 	6
C		equ 	5
B		equ 	4
Right		equ 	3
Left		equ 	2
Down		equ 	1
Up		equ 	0

; -------------------------------------------------------------------------------------------
; OUT command flags
signed		equ	1<<7
trim		equ	1<<6
*nobr		equ	1<<5
dec		equ	1<<1
bin		equ	1

; -------------------------------------------------------------------------------------------
; $8000-830C -  Workspace chars array
; 	Note:	first byte defines row pallete, the size is 20 * 39 = 780 bytes ($30C)
SysWorkspace	equ	$FFFF8000	;	current workspace
SysWorkspace2	equ	$FFFF9000	;	saved workspace (console data)

; -------------------------------------------------------------------------------------------
; $8400-8420 -	Data States for Text View engine
;	Format:	See in Textview.asm
SysTextState1	equ	$FFFF8400	;	Filelist view state
SysTextState2	equ	$FFFF8410	;	Source code view state

; -------------------------------------------------------------------------------------------
; $8420 - RAM View Engine state variables
SysRAMStartRow	equ	$FFFF8420	; [w]	Start row on screen
SysRAMCurrRow	equ	$FFFF8422	; [w]	Current row
SysRAMOverride	equ	$FFFF8424	; [b]	Override flag
SysRAMViewInit	equ	$FFFF8425	; [b]	Init flag

; -------------------------------------------------------------------------------------------
; $8500 - Variables for the Console Engine
SysConsoleRow	equ	$FFFF8500	; [w]	pointer to the begining of the current row
SysConsolePos	equ	$FFFF8502	; [w]	pointer to the position in the current row
SysInputBuff	equ	$FFFF8504	; [l]	console input buffer (for numeric data)
SysOutputBuff	equ	$FFFF8508	;	console output buffer (for numeric data)

SysConsoleInit	equ	$FFFF8F00	; [b]	console init flag, if set workspace backup will be loaded

; -------------------------------------------------------------------------------------------
; $FF00	- Custom variables block
SysKeyCounter	equ	$FFFFFF00	; [b]	Counter to delay operation when key is held
SysDelayCounter	equ	$FFFFFF01	; [b]	Counter to delay a program
SysPragmaPC	equ	$FFFFFF02	; [l]	Pointer to last instruction offset in program

SysRegBuff	equ	$FFFFFC00	;	Registers buffer

; -------------------------------------------------------------------------------------------
; $FFF0 - Main system data
SysScreenId	equ	$FFFFFFF0	; [b]	Screen Id
SysModeId	equ	$FFFFFFF1	; [b]	System Mode
SysStatusId	equ	$FFFFFFF2	; [b]	Status string index
SysVBlaProcess	equ	$FFFFFFF3	; [b]	Wait for VBlank flag
SysJoypadHeld	equ	$FFFFFFF4	; [b]	Joypad input - held
SysJoypadPress	equ	$FFFFFFF5	; [b]	Joypad input - press
SysErrorId	equ	$FFFFFFF6	; [b]	Number of last error
*			$FFFFFFF8	; [b]	MD data
